﻿using System;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 테스트 데이터
    /// </summary>
    public class TestData
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 명칭 - Name

        /// <summary>
        /// 명칭
        /// </summary>
        public string Name { get; set; }

        #endregion
        #region 일자 - Date

        /// <summary>
        /// 일자
        /// </summary>
        public DateTime Date { get; set; }

        #endregion
        #region 값 - Value

        /// <summary>
        /// 값
        /// </summary>
        public decimal Value { get; set; }

        #endregion
        #region 타입 - Type

        /// <summary>
        /// 타입
        /// </summary>
        public string Type { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TestData(name, date, value, type)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="name">명칭</param>
        /// <param name="date">일자</param>
        /// <param name="value">값</param>
        /// <param name="type">타입</param>
        public TestData(string name, DateTime date, decimal value, string type)
        {
            Name  = name;
            Date  = date;
            Value = value;
            Type  = type;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 테스트 데이터 리스트 구하기 - GetTestDataList()

        /// <summary>
        /// 테스트 데이터 리스트 구하기
        /// </summary>
        /// <returns>테스트 데이터 리스트</returns>
        public static List<TestData> GetTestDataList()
        {
            DateTime startDate = new DateTime(2019, 10, 15);

            List<TestData> list = new List<TestData>
            {
                new TestData("부서1", startDate                       , 7 , "수입"),
                new TestData("부서1", startDate.AddDays(1)            , 4 , "지출"),
                new TestData("부서2", startDate                       , 12, "지출"),
                new TestData("부서2", startDate.AddDays(1)            , 14, "지출"),
                new TestData("부서3", startDate                       , 11, "수입"),
                new TestData("부서3", startDate.AddDays(1)            , 10, "수입"),
                new TestData("부서1", startDate.AddYears(1)           , 4 , "수입"),
                new TestData("부서1", startDate.AddYears(1).AddDays(1), 2 , "수입"),
                new TestData("부서2", startDate.AddYears(1)           , 3 , "수입"),
                new TestData("부서2", startDate.AddDays(1).AddYears(1), 1 , "지출"),
                new TestData("부서3", startDate.AddYears(1)           , 8 , "수입"),
                new TestData("부서3", startDate.AddDays(1).AddYears(1), 22, "지출")
            };

            return list;
        }

        #endregion
    }
}